#include <bits/stdc++.h>

using namespace std;

const int N = 2001;
vector<int> g[N];

int max_dist[N];

void calc(int v, int p) {
    max_dist[v] = 0;
    for (auto u: g[v]) {
        if (u != p)
            calc(u, v);
    }
    for (auto u: g[v]) {
        if (u != p)
            max_dist[v] = max(max_dist[v], max_dist[u] + 1);
    }
}

int cnt = 0;
int d;

void dfs(int v, int p, int dist) {
    if (dist > d) {
        cnt++;
        dist = 1;
    }
    if (max_dist[v] + 1 <= d)
        return;
    for (auto u: g[v]) {
        if (u != p)
            dfs(u, v, dist + 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    if (n > 2000) {
        // TODO
        return 0;
    }
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].emplace_back(v - 1);
        g[v - 1].emplace_back(u - 1);
    }

    for (int s = 0; s < n; s++) {
        calc(s, -1);
        int l = 0, r = n;
        while (r - l > 1) {
            d = (l + r) / 2;
            cnt = 0;
            dfs(s, -1, 0);
            if (cnt <= k)
                r = d;
            else
                l = d;
        }
        cout << r << " ";
    }
    return 0;
}