#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 200010;
vector<int> g[N];

int pr[N], used[N];

void dfs(int v, int p) {
    pr[v] = p;
    for (auto u: g[v]) {
        if (u != p)
            dfs(u, v);
    }
}

void mark(int v, int p) {
    used[v] = true;
    for (auto u: g[v]) {
        if (u != p && !used[u])
            mark(u, v);
    }
}

int distt[N], max_distt[N];

void calcc(int v, int p) {
    for (auto u: g[v]) {
        if (u != p) {
            distt[u] = distt[v] + 1;
            calcc(u, v);
        }
    }
    max_distt[v] = distt[v];
    for (auto u: g[v]) {
        if (u != p)
            max_distt[v] = max(max_distt[v], max_distt[u]);
    }
}

int ans = (int) 1e18;

void dfss(int v, int p, int mx) {
    multiset<int> all;
    for (auto u: g[v]) {
        if (u != p)
            all.insert(max_distt[u]);
    }
    ans = min(ans, max(mx, max_distt[v] - distt[v] + 1));
    for (auto u: g[v]) {
        if (u != p) {
            all.erase(all.find(max_distt[u]));
            dfss(u, v, max({mx, (all.empty() ? 0 : *all.rbegin()), distt[v]}));
            all.insert(max_distt[u]);
        }
    }
}

int solve(int n, int l) {
    if (l == 1)
        return max(0ll, n - 2);
    int cnt = (n - 1), anss = 0;
    cnt = cnt - l - 1;
    if (cnt > 0) anss += cnt / l + (cnt % l != 0);
    return anss;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].emplace_back(v - 1);
        g[v - 1].emplace_back(u - 1);
    }
    if (t == 0) {

        if (k == 1 && t == 0) {
            calcc(0, -1);
            dfss(0, -1, 0);
            cout << ans;
        } else {
            for (int i = 0; i < (t == 0 ? 1 : n); i++) {
                int l = i + 1, r = (n - i);
                int L = 0, R = n;
                while (R - L > 1) {
                    int M = (L + R) / 2;
                    if (solve(r, M) + solve(l, M) <= k)
                        R = M;
                    else
                        L = M;
                }
                cout << R << " ";
            }
        }
        return 0;
    }
    for (int s = 0; s < (t == 0 ? 1 : n); s++) {
        vector<int> ord, dist(n, (int) 1e9);
        queue<int> q;
        q.push(s);
        dist[s] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            ord.emplace_back(v);
            for (auto u: g[v]) {
                if (dist[u] == (int) 1e9) {
                    dist[u] = dist[v] + 1;
                    q.push(u);
                }
            }
        }
        reverse(ord.begin(), ord.end());
        dfs(s, -1);
        int l = 0, r = n;
        while (r - l > 1) {
            int d = (l + r) / 2, cnt = 0;
            if (d == 1) {
                cnt = n - 1 - (int) g[s].size();
            } else {
                for (int j = 0; j < n; j++)
                    used[j] = false;
                for (int j = 0; j < n; j++) {
                    int v = ord[j];
                    if (cnt > k) {
                        break;
                    }
                    if (used[v])
                        continue;
                    if (dist[v] <= d)
                        break;
                    int u = v, cur = 0;
                    while (u != -1 && cur < d - 1) {
                        cur++;
                        u = pr[u];
                    }
                    mark(u, pr[u]);
                    cnt++;
                }
            }
            if (cnt <= k)
                r = d;
            else
                l = d;
        }
        cout << r << " ";
    }
    return 0;
}