#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = (int) 1e6 + 1;

bool del[N];
bool prime[N], used[N];
vector<int> p;
vector<int> g[N];
int col[N];

void dfs(int v){
    used[v] = true;
    for(auto u : g[v]){
        if(!used[u]){
            col[u] = 1 - col[v];
            dfs(u);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    for (int i = 2; i < N; i++) {
        if (del[i])
            continue;
        prime[i] = true;
        p.emplace_back(i);
        int j = i * i;
        while (j < N)
            del[j] = true, j += i;
    }
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].first, a[i].second = i;
    sort(a.rbegin(), a.rend());
    for (int i = n - 1; i >= 0; i--) {
        if (i + 1 < n && a[i].first == a[i + 1].first)
            continue;
        for (int j = 1; j * j <= a[i].first; j++) {
            if (a[i].first % j == 0) {
                if (prime[a[i].first / j])
                    g[a[i].first].emplace_back(j), g[j].emplace_back(a[i].first);
                if(prime[j] && j * j != a[i].first)
                    g[a[i].first].emplace_back(a[i].first / j), g[a[i].first / j].emplace_back(a[i].first);
            }
        }
    }
    for(int i = 1; i < N; i++){
        if(!used[i])
            dfs(i);
    }
    int ans[n];
    for(int i = 0; i < n; i++) ans[a[i].second] = col[a[i].first];
    for(int i = 0; i < n; i++) cout << ans[i] + 1 << " ";
    return 0;
}