#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 200010;
vector<int> g[N];
int dist[N], max_dist[N];

void calc(int v, int p) {
    for (auto u: g[v]) {
        if (u != p) {
            dist[u] = dist[v] + 1;
            calc(u, v);
        }
    }
    max_dist[v] = dist[v];
    for (auto u: g[v]) {
        if (u != p)
            max_dist[v] = max(max_dist[v], max_dist[u]);
    }
}

int ans = (int) 1e18;

void dfs(int v, int p, int mx) {
    multiset<int> all;
    for (auto u: g[v]) {
        if (u != p)
            all.insert(max_dist[u]);
    }
    ans = min(ans, max(mx, max_dist[v] - dist[v] + 1));
    for (auto u: g[v]) {
        if (u != p) {
            all.erase(all.find(max_dist[u]));
            dfs(u, v, max({mx, (all.empty() ? 0 : *all.rbegin()), dist[v]}));
            all.insert(max_dist[u]);
        }
    }
}

int solve(int n, int l) {
    if(l == 1)
        return max(0ll, n - 2);
    return (n - 1) / l - ((n - 1) % l == 0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].emplace_back(v - 1);
        g[v - 1].emplace_back(u - 1);
    }
    if (k == 1 && t == 0) {
        calc(0, -1);
        dfs(0, -1, 0);
        cout << ans;
    } else {
        for (int i = 0; i < (t == 0 ? 1 : n); i++) {
            int l = i + 1, r = (n - i);
            int L = 0, R = n;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (solve(r, M) + solve(l, M) <= k)
                    R = M;
                else
                    L = M;
            }
            cout << R << " ";
        }
    }
    return 0;
}