#include <bits/stdc++.h>

using namespace std;
#define int long long

int n, k, t;

const int N = 2001;
vector<int> g[N];

int pr[N], used[N];

void dfs(int v, int p) {
    pr[v] = p;
    for (auto u: g[v]) {
        if (u != p)
            dfs(u, v);
    }
}

void mark(int v, int p) {
    used[v] = true;
    for (auto u: g[v]) {
        if (u != p && !used[u])
            mark(u, v);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].emplace_back(v - 1);
        g[v - 1].emplace_back(u - 1);
    }
    for (int s = 0; s < (t == 0 ? 1 : n); s++) {
        vector<int> ord, dist(n, (int) 1e9);
        queue<int> q;
        q.push(s);
        dist[s] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            ord.emplace_back(v);
            for (auto u: g[v]) {
                if (dist[u] == (int) 1e9) {
                    dist[u] = dist[v] + 1;
                    q.push(u);
                }
            }
        }
        reverse(ord.begin(), ord.end());
        dfs(s, -1);
        int l = 0, r = n;
        while (r - l > 1) {
            int d = (l + r) / 2, cnt = 0;
            if(d == 1){
                cnt = n - 1 - (int)g[s].size();
            }else {
                for (int j = 0; j < n; j++)
                    used[j] = false;
                for (int j = 0; j < n; j++) {
                    int v = ord[j];
                    if (used[v])
                        continue;
                    if(dist[v] <= d)
                        break;
                    int u = v, cur = 0;
                    while (u != -1 && cur < d - 1) {
                        cur++;
                        u = pr[u];
                    }
                    mark(u, pr[u]);
                    cnt++;
                }
            }
            if (cnt <= k)
                r = d;
            else
                l = d;
        }
        cout << r << " ";
    }
    return 0;
}